!           Library for Inform / Glulx (display time (hour:minutes) in the status line)
! ----------------------------------------------------------------------------
!  Except in Version 3, the DrawStatusLine routine does just that: this is
!  provided explicitly so that it can be Replace'd to change the style, and
!  as written it emulates the ordinary Standard game status line, which is
!  drawn in hardware
! ----------------------------------------------------------------------------

Global Sline3;

! use Include	"DrawStatusTimeGx";  after  Include "grammar";
! use also 
! Replace DrawStatusLine;
! Replace StatusLineHeight;
! Replace DisplayStatus;
! before include "parse";
!
! You can also uncomment some code below to have status in english (and comment the french
!  part, or replace Heure by Time etc. ... I think it's nicer like that than the default.
!   (I didn't manage to replace the constant TIME__TX etc. without changing the 
!   original library)
! You can easily change the position of the text with posa = width-39 etc.
! Well, and the code doesn't seem to work for the z-machine yet...



#ifdef TARGET_ZCODE;

#IFV5;
[ DrawStatusLine width posa posb;
   @split_window 1; @set_window 1; @set_cursor 1 1; style reverse;
   width = 0->33; posa = width-26; posb = width-13;
   spaces width;
   @set_cursor 1 2;
   if (location == thedark) print (name) location;
   else
   {   FindVisibilityLevels();
       if (visibility_ceiling == location)
           print (name) location;
       else print (The) visibility_ceiling;
   }
   if ((0->1)&2 == 0)
   {   if (width > 76)
       {   @set_cursor 1 posa; print (string) SCORE__TX, sline1;
           @set_cursor 1 posb; print (string) MOVES__TX, sline2;
       }
       if (width > 63 && width <= 76)
       {   @set_cursor 1 posb; print sline1, "/", sline2;
       }
   }
   else
   {   @set_cursor 1 posa;
       print (string) TIME__TX;
       LanguageTimeOfDay(sline1, sline2);
   }
   @set_cursor 1 1; style roman; @set_window 0;
];
#ENDIF;
#endif; ! TARGET_ZCODE

#ifdef TARGET_nothing;  ! code to be corrected...
[ DrawStatusLine width posa posb posc;
   @split_window 1; @set_window 1; @set_cursor 1 1; style reverse;
   width = 0->43; posa = width-39; posb = width-26; posc = width-13;
   spaces width;
   @set_cursor 1 2;
   if (location == thedark) print (name) location;
   else
   {   FindVisibilityLevels();
       if (visibility_ceiling == location)
           print (name) location;
       else print (The) visibility_ceiling;
   }
   if ((0->1)&2 == 0)
   {   if (width > 76)
       {   @set_cursor 1 posa; print (string) SCORE__TX, sline1;
           @set_cursor 1 posb; print (string) MOVES__TX, sline2;
	@set_cursor 1 posc; print (string) TIME__TX, sline3;
       }
       if (width > 60 && width <= 76)
!     {   @set_cursor 1 posb; print sline1, print "/", print sline2, print "/", print sline3;
       {   @set_cursor 1 posb; print sline1, "/", sline2; 
      }
   }
   else
   {   @set_cursor 1 posa;
       print (string) TIME__TX;
       LanguageTimeOfDay(sline1, sline2, sline3);
   }
   @set_cursor 1 1; style roman; @set_window 0;
];


#endif; ! TARGET_nothing
 
#ifdef TARGET_GLULX; 

[ StatusLineHeight hgt parwin;
  if (gg_statuswin == 0)
    return;
  if (hgt == gg_statuswin_cursize)
    return;
  parwin = glk($0029, gg_statuswin); ! window_get_parent
  glk($0026, parwin, $12, hgt, 0); ! window_set_arrangement
  gg_statuswin_cursize = hgt;
];

[ DrawStatusLine width height posa posb posc;
    ! If we have no status window, we must not try to redraw it.
    if (gg_statuswin == 0)
        return;

    ! If there is no player location, we shouldn't try either.
    if (location == nothing || parent(player) == nothing)
        return;

    glk($002F, gg_statuswin); ! set_window
    StatusLineHeight(gg_statuswin_size);

    glk($0025, gg_statuswin, gg_arguments, gg_arguments+4); ! window_get_size
    width = gg_arguments-->0;
    height = gg_arguments-->1;
    posa = width-39; posb = width-26; posc = width-13;

    glk($002A, gg_statuswin); ! window_clear

    glk($002B, gg_statuswin, 1, 0); ! window_move_cursor
    if (location == thedark) {
        print (name) location;
    }
    else {
        FindVisibilityLevels();
        if (visibility_ceiling == location)
            print (name) location;
        else 
            print (The) visibility_ceiling;
    }

    if (width > 67) {
        glk($002B, gg_statuswin, posa-1, 0); ! window_move_cursor
!        print (string) SCORE__TX, sline1;
        print "Score ", sline1;
        glk($002B, gg_statuswin, posb-1, 0); ! window_move_cursor
!        print (string) MOVES__TX, day;
        print "Jour ", day;
        glk($002B, gg_statuswin, posb-1, 0); ! window_move_cursor
!        print (string) MOVES__TX, sline2;
        print (string) "Jour ", day;
        glk($002B, gg_statuswin, posc-1, 0); ! window_move_cursor
 !       if (sline3 ~= 0) {print (string) TIME__TX, sline3/60, ":", sline3%60;}
       if (sline3 ~= 0 && sline3%60 < 10) {print "Heure ", sline3/60, ":0", sline3%60;}  
       if (sline3 ~= 0 && sline3%60 >= 10) {print "Heure ", sline3/60, ":", sline3%60;}  
  }
    if (width > 53 && width <= 67) {
        glk($002B, gg_statuswin, posb-1, 0); ! window_move_cursor
if (sline3 ~= 0) {
        print sline1, "/", sline2, "/", sline3/60, ":", sline3%60;
}
    }

    glk($002F, gg_mainwin); ! set_window
];

   #endif; ! TARGET_

[ DisplayStatus;
   if (the_time==NULL)
   {   sline1=score; sline2=turns; }
   else
   {   sline1=score; sline2=turns; sline3=the_time; }
];


